#!/usr/bin/env python

"Make the API documentation."

import pydoc
import os, sys

if __name__ == "__main__":

    # The list of packages should coincide with that found in setup.py.

    names = [
        "WebStack", "WebStack.__init__",
        "WebStack.BaseHTTPRequestHandler", "WebStack.CGI", "WebStack.Generic",
        "WebStack.JavaServlet", "WebStack.ModPython", "WebStack.Twisted",
        "WebStack.Webware",
        "WebStack.Adapters", "WebStack.Adapters.__init__",
        "WebStack.Adapters.BaseHTTPRequestHandler", "WebStack.Adapters.CGI",
        "WebStack.Adapters.Generic", "WebStack.Adapters.JavaServlet",
        "WebStack.Adapters.ModPython", "WebStack.Adapters.Twisted",
        "WebStack.Adapters.Webware",
        "WebStack.Helpers", "WebStack.Helpers.__init__",
        "WebStack.Helpers.Auth", "WebStack.Helpers.Environment",
        "WebStack.Helpers.Request", "WebStack.Helpers.Response",
        "WebStack.Resources", "WebStack.Resources.__init__",
        "WebStack.Resources.Login", "WebStack.Resources.LoginRedirect"
        ]

    dirname = "apidocs"

    # Set the PYTHONPATH to find the package.

    sys.path.insert(0, os.getcwd())

    # Make the documentation directory if necessary.

    if not os.path.exists(dirname):
        print "Making", dirname
        os.mkdir(dirname)

    # Change into the directory - pydoc.writedoc depends on that.

    os.chdir(dirname)

    for name in names:
        pydoc.writedoc(name, forceload=1)

# vim: tabstop=4 expandtab shiftwidth=4
